 
/*--------------------------------------------------------------*/
/*	All code in this file by IQ_132				*/
/*	http://www.freepgs.com/iq_132				*/
/*	http://neosource.1emulation.com				*/
/*	Thanks to Jimmy_Page for beta testing			*/
/*	Please do not remove these credits from this file	*/
/*--------------------------------------------------------------*/

#include "neogeo.h"

// The above contains 10kb of data from the bios rom. This controls the "zoom" effects in the game.

unsigned short patch_bank[256] = {
	0xE7, 0x48, 0xFE, 0xFF, 0x71, 0x4E, 0x3C, 0x10, 0x00, 0x00, 0x39, 0x12, 0x2F, 0x00, 0xE9, 0xFF, 
	0x09, 0xE2, 0x01, 0x80, 0x39, 0x12, 0x2F, 0x00, 0xE8, 0xFF, 0x09, 0xE2, 0x09, 0xE9, 0x01, 0x80, 
	0xC0, 0x13, 0x2F, 0x00, 0xED, 0xFF, 0x3C, 0x10, 0x00, 0x00, 0x39, 0x12, 0x2F, 0x00, 0xEB, 0xFF, 
	0x09, 0xE2, 0x01, 0x80, 0x39, 0x12, 0x2F, 0x00, 0xE9, 0xFF, 0x01, 0x02, 0x01, 0x00, 0x09, 0xE9, 
	0x01, 0x80, 0x39, 0x12, 0x2F, 0x00, 0xE8, 0xFF, 0x01, 0x02, 0x01, 0x00, 0x09, 0xEB, 0x01, 0x80, 
	0x39, 0x12, 0x2F, 0x00, 0xEB, 0xFF, 0x01, 0x02, 0x01, 0x00, 0x09, 0xED, 0x01, 0x80, 0x39, 0x12, 
	0x2F, 0x00, 0xEA, 0xFF, 0x09, 0xEF, 0x01, 0x80, 0xC0, 0x13, 0x2F, 0x00, 0xEC, 0xFF, 0x71, 0x4E, 
	0xDF, 0x4C, 0xFF, 0x7F, 0xF9, 0x36, 0x2F, 0x00, 0xEC, 0xFF, 0x75, 0x4E, 0xFF, 0xFF, 0xFF, 0xFF,
	0x39, 0x18, 0x2F, 0x00, 0xE0, 0xFF, 0x39, 0x16, 0x2F, 0x00, 0xE1, 0xFF, 0x0C, 0xE8, 0x04, 0x02, 
	0x01, 0x00, 0x03, 0x02, 0x0F, 0x00, 0x0B, 0xE3, 0x04, 0xD6, 0xC3, 0x13, 0x2F, 0x00, 0xE3, 0xFF, 
	0x39, 0x18, 0x2F, 0x00, 0xE0, 0xFF, 0x39, 0x16, 0x2F, 0x00, 0xE1, 0xFF, 0x0C, 0xEA, 0x04, 0x02, 
	0x01, 0x00, 0x0B, 0xE8, 0x3C, 0xC6, 0x0F, 0x00, 0x0B, 0xE3, 0x04, 0xD6, 0xC3, 0x13, 0x2F, 0x00, 
	0xE2, 0xFF, 0x39, 0x18, 0x2F, 0x00, 0xE0, 0xFF, 0x39, 0x16, 0x2F, 0x00, 0xE0, 0xFF, 0x0C, 0xEC, 
	0x04, 0x02, 0x01, 0x00, 0x3C, 0xC6, 0x0F, 0x00, 0x0B, 0xE3, 0x04, 0xD6, 0xC3, 0x13, 0x2F, 0x00, 
	0xE5, 0xFF, 0x39, 0x18, 0x2F, 0x00, 0xE0, 0xFF, 0x0C, 0xEE, 0xC4, 0x13, 0x2F, 0x00, 0xE4, 0xFF, 
	0x39, 0x18, 0x2F, 0x00, 0xE0, 0xFF, 0x39, 0x16, 0x2F, 0x00, 0xE1, 0xFF, 0xDF, 0x4C, 0xFF, 0x7F
};

// The above contains data tables located at 0xBA100, 0xBA300, and 0xBB000 of the bootleg P roms.
// I'm almost sure this patches out one of the bankswitch protections. There are similar tables in 
// the (decrypted) svcboot P data.

void do_kof2003_patch()
{
	int i,j;

	for (i = 0; i < 0x100000; i++)
	{
		if ((i==0x770)||(i==0x792)||(i==0x7B6)||(i==0x7DA))
		{
			for (j = 0; j < 3; j=j+2)
			{
				*((unsigned short*)(Neo68KROM01 + i + j)) = 0x4e71;
			}
		}
		if (i < 0x2800)
		{
			if (*((unsigned short*)(Neo68KROM01 + 0x50000 + i)) == 0x00C2)
			{
				*((unsigned short*)(Neo68KROM01 + 0x50000 + i)) = 0x0005;
			}
		}
		if (i < 128)
		{
			*((unsigned short*)(Neo68KROM01 + 0xBA100 + i)) = patch_bank[i];
			*((unsigned short*)(Neo68KROM01 + 0xBA300 + i)) = patch_bank[i];
			*((unsigned short*)(Neo68KROM01 + 0xBB000 + i)) = patch_bank[i+128];
		}
		if ((i >= 0x59C) && (i <= 0x44012))
		{
			if (((*((unsigned short*)(Neo68KROM01 + i + 0))==0x4EB9) ||
			     (*((unsigned short*)(Neo68KROM01 + i + 0))==0x4EF9)) &&
			     (*((unsigned short*)(Neo68KROM01 + i + 2))==0x00C2))
			{
				*((unsigned short*)(Neo68KROM01 + i + 2)) = 0x0005;
			}
		}
		if ((i==0xBAA0A)||(i==0xBAB0A)||(i==0xBAC0A)||(i==0xBAD0A)) // intervals of 256 bytes
		{
			*((unsigned short*)(Neo68KROM01 + i + 0)) = 0x4EF9;//F9
			*((unsigned short*)(Neo68KROM01 + i + 2)) = 0x000B;
			*((unsigned short*)(Neo68KROM01 + i + 4)) = 0xB000;
		}
		if ((i==0x1B826)||(i==0x1B8D2)||(i==0x1B930)||(i==0x1B9CC)||(i==0x1BA28)||(i==0x1BE2E)||
		    (i==0x1BECA)||(i==0x1C0D6)||(i==0x1C184)||(i==0x1C260)||(i==0x1C9F0)||(i==0x1CC4A)||
		    (i==0x1CD00)||(i==0x1CD62)||(i==0x1CD94)||(i==0x1CDC6)||(i==0x1CDF8)||(i==0x1CE1C)||
		    (i==0x1BFAC))
		{
			*((unsigned short*)(Neo68KROM01 + i + 0)) = 0x4EB9;
			*((unsigned short*)(Neo68KROM01 + i + 2)) = 0x000B;
		}
		if ((i == 0xBAA02)||(i == 0xBAD02))
		{
			*((unsigned short*)(Neo68KROM01 + i + 0)) = 0x002F;
			*((unsigned short*)(Neo68KROM01 + i + 2)) = 0xFFE0;
			*((unsigned short*)(Neo68KROM01 + i + 4)) = 0x48E7;
			*((unsigned short*)(Neo68KROM01 + i + 6)) = 0xFFFE;
		}
	}

	*((unsigned short*)(Neo68KROM01 + 0x14A18)) = 0x0005;
	*((unsigned short*)(Neo68KROM01 + 0x19768)) = 0x0005;
	*((unsigned short*)(Neo68KROM01 + 0x19864)) = 0x0005;
	*((unsigned short*)(Neo68KROM01 + 0x1B82A)) = 0xA100;
	*((unsigned short*)(Neo68KROM01 + 0x1B8D6)) = 0xAA00;
	*((unsigned short*)(Neo68KROM01 + 0x1B934)) = 0xA300;
	*((unsigned short*)(Neo68KROM01 + 0x1BE32)) = 0xAD00;
	*((unsigned short*)(Neo68KROM01 + 0x1BFB0)) = 0xA100;
	*((unsigned short*)(Neo68KROM01 + 0x1C0DA)) = 0xA100;
	*((unsigned short*)(Neo68KROM01 + 0xBA374)) = 0x30F9;
	*((unsigned short*)(Neo68KROM01 + 0xBAA00)) = 0x33D9;
	*((unsigned short*)(Neo68KROM01 + 0xBAD00)) = 0x33D8;
	*((unsigned short*)(Neo68KROM01 + 0xBB080)) = 0x4E75;
}
